/* ============================================================================================== *
 *                                                                                                *
 *                                       Xi Blockchain                                            *
 *                                                                                                *
 * ---------------------------------------------------------------------------------------------- *
 * This file is part of the Galaxia Project - Xi Blockchain                                       *
 * ---------------------------------------------------------------------------------------------- *
 *                                                                                                *
 * Copyright 2018-2019 Galaxia Project Developers                                                 *
 *                                                                                                *
 * This program is free software: you can redistribute it and/or modify it under the terms of the *
 * GNU General Public License as published by the Free Software Foundation, either version 3 of   *
 * the License, or (at your option) any later version.                                            *
 *                                                                                                *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;      *
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
 * See the GNU General Public License for more details.                                           *
 *                                                                                                *
 * You should have received a copy of the GNU General Public License along with this program.     *
 * If not, see <https://www.gnu.org/licenses/>.                                                   *
 *                                                                                                *
 * ============================================================================================== */

#include <gmock/gmock.h>

#include <Xi/Rct/Constants.h>
#include <Xi/Rct/Algorithm/KeyArithmetic.h>

#define XI_TESTSUITE T_Xi_Rct_KeyArithmetic

TEST(XI_TESTSUITE, PointScalar) {
  using namespace ::testing;
  using namespace ::Xi;
  using namespace ::Xi::Rct;

  std::vector<std::pair<KeyVector, Rct::Key>> Oracle{{
      {{{{0x13, 0xf5, 0xf0, 0x53, 0x76, 0x57, 0xb5, 0x6c, 0x6e, 0x98, 0x7f, 0xb5, 0x76, 0xa8, 0x26, 0x1a,
          0xc4, 0xb8, 0xe6, 0xa8, 0xcb, 0x4b, 0x8,  0x27, 0x2a, 0x28, 0x45, 0xc1, 0x5b, 0x25, 0xc9, 0xce},
         {0x95, 0xb6, 0x47, 0xbf, 0x14, 0x74, 0xd8, 0x57, 0x8e, 0xd5, 0x62, 0x21, 0x69, 0x4c, 0x2d, 0x81,
          0x2a, 0x90, 0xb,  0xd4, 0x3,  0x5a, 0x43, 0xe5, 0xcb, 0x44, 0xba, 0xae, 0x21, 0xbc, 0xc4, 0x1}}},
       {{0xdb, 0x64, 0xf9, 0x6,  0x73, 0x60, 0x46, 0xfa, 0x4a, 0x15, 0x70, 0x33, 0x76, 0x56, 0x76, 0xf,
         0xd9, 0xcd, 0x38, 0x59, 0xc7, 0xf9, 0x12, 0x5c, 0xc2, 0xd9, 0xd3, 0xaa, 0x1c, 0x1f, 0x9f, 0x9b}}},
      {{{{0x13, 0xf5, 0xf0, 0x53, 0x76, 0x57, 0xb5, 0x6c, 0x6e, 0x98, 0x7f, 0xb5, 0x76, 0xa8, 0x26, 0x1a,
          0xc4, 0xb8, 0xe6, 0xa8, 0xcb, 0x4b, 0x8,  0x27, 0x2a, 0x28, 0x45, 0xc1, 0x5b, 0x25, 0xc9, 0xce},
         {0x93, 0xa7, 0xe8, 0xcb, 0x20, 0x4b, 0xa0, 0x11, 0x96, 0xec, 0x98, 0x45, 0xbc, 0xaa, 0x80, 0x3f,
          0x0,  0xc1, 0x33, 0xbe, 0x38, 0xe2, 0xd8, 0x76, 0xc1, 0x58, 0xcf, 0x80, 0x6e, 0xf6, 0x48, 0x3}}},
       {{0x7c, 0x6, 0x8,  0xd,  0x74, 0xde, 0xe6, 0x38, 0x78, 0x4b, 0x6a, 0x92, 0x7f, 0x90, 0x5a, 0xe9,
         0xc6, 0x1, 0x43, 0x50, 0x65, 0xb9, 0xdd, 0x4d, 0x1d, 0x20, 0x2,  0x71, 0xc5, 0x37, 0x70, 0xbc}}},
      {{{{0x76, 0xed, 0x2d, 0x93, 0x43, 0xb5, 0x50, 0x2f, 0xe8, 0x2c, 0xf5, 0xcb, 0xae, 0x3e, 0xc0, 0x38,
          0xdf, 0xbe, 0x49, 0xf6, 0x12, 0x1e, 0x49, 0x83, 0x1a, 0x1a, 0x9e, 0xb0, 0xbd, 0xc7, 0x39, 0x3c},
         {0x92, 0x4f, 0x69, 0x9a, 0xfe, 0x30, 0xac, 0xe1, 0x95, 0xfb, 0x2,  0x83, 0x1a, 0x1e, 0xc3, 0xc9,
          0xd6, 0xfe, 0xc7, 0xfc, 0x57, 0xf2, 0xb6, 0x58, 0xfa, 0xab, 0xea, 0xe0, 0x58, 0x18, 0x73, 0x0}}},
       {{0x33, 0xad, 0xc0, 0x2f, 0xa,  0xa,  0x6f, 0x62, 0x19, 0x1e, 0xd6, 0x7b, 0xb6, 0x17, 0x44, 0x75,
         0x1,  0x6b, 0x3b, 0xd5, 0xfb, 0x9f, 0x8f, 0xb2, 0xd,  0xec, 0x24, 0x88, 0xa0, 0x1f, 0xff, 0x68}}},
      {{{{0x76, 0xed, 0x2d, 0x93, 0x43, 0xb5, 0x50, 0x2f, 0xe8, 0x2c, 0xf5, 0xcb, 0xae, 0x3e, 0xc0, 0x38,
          0xdf, 0xbe, 0x49, 0xf6, 0x12, 0x1e, 0x49, 0x83, 0x1a, 0x1a, 0x9e, 0xb0, 0xbd, 0xc7, 0x39, 0x3c},
         {0xde, 0xcb, 0x42, 0x67, 0x48, 0x59, 0x76, 0xda, 0x5e, 0xd4, 0xed, 0x48, 0x6a, 0xe5, 0xe9, 0x74,
          0xca, 0xc9, 0x57, 0x52, 0x8c, 0x71, 0xb0, 0x23, 0xde, 0x2c, 0xfb, 0x8a, 0x77, 0x78, 0x5c, 0x1}}},
       {{0x2a, 0x4d, 0x83, 0x53, 0x8a, 0xb8, 0x7e, 0x91, 0x39, 0xf5, 0x7, 0x62, 0xa0, 0x77, 0x23, 0x28,
         0x78, 0x2e, 0x78, 0x9e, 0xd,  0xf1, 0x5c, 0xa0, 0x4,  0x6d, 0x7, 0x44, 0x55, 0xe8, 0x64, 0x13}}},
      {{{{0x92, 0x22, 0x2a, 0x37, 0x9c, 0xc8, 0xb9, 0x59, 0xe8, 0xcc, 0x37, 0x76, 0x30, 0x80, 0x3b, 0xe5,
          0xde, 0x99, 0xd8, 0xd3, 0x79, 0x62, 0xcd, 0xb1, 0x27, 0xaa, 0xf6, 0xe5, 0x7c, 0x42, 0xc3, 0xdb},
         {0xc8, 0x9f, 0x1e, 0x7d, 0x71, 0xf8, 0x9c, 0xf0, 0xf6, 0x55, 0x61, 0x2a, 0xf4, 0xb8, 0xf5, 0x48,
          0x57, 0x13, 0xbc, 0x3d, 0xcb, 0xac, 0xf1, 0x78, 0xb5, 0x9e, 0xe6, 0xc3, 0xbb, 0x25, 0xc7, 0x7}}},
       {{0x70, 0xe8, 0x15, 0x34, 0xdf, 0xd9, 0x77, 0x5a, 0xfd, 0xee, 0xfa, 0x70, 0xd6, 0xd5, 0x78, 0xbb,
         0x24, 0xb7, 0xfc, 0x41, 0x62, 0x9d, 0xff, 0x65, 0x63, 0xec, 0x19, 0xd4, 0x10, 0x49, 0x69, 0x46}}},
      {{{{0x92, 0x22, 0x2a, 0x37, 0x9c, 0xc8, 0xb9, 0x59, 0xe8, 0xcc, 0x37, 0x76, 0x30, 0x80, 0x3b, 0xe5,
          0xde, 0x99, 0xd8, 0xd3, 0x79, 0x62, 0xcd, 0xb1, 0x27, 0xaa, 0xf6, 0xe5, 0x7c, 0x42, 0xc3, 0xdb},
         {0xc8, 0xe4, 0x98, 0x8c, 0x6d, 0xed, 0xca, 0xc3, 0x9b, 0x94, 0x17, 0x38, 0xb8, 0x9c, 0x98, 0x28,
          0x65, 0x9d, 0xc1, 0xc7, 0xe0, 0x61, 0x7,  0xdc, 0xfd, 0x4b, 0x6c, 0x33, 0xfd, 0x2,  0x50, 0x7}}},
       {{0x30, 0x8c, 0x4,  0xdc, 0x8,  0x6b, 0x98, 0x30, 0xc4, 0x70, 0xef, 0x47, 0xb4, 0xc1, 0xf9, 0xaa,
         0xb1, 0x60, 0xeb, 0xa6, 0xce, 0xb8, 0xb7, 0xc6, 0xe4, 0x61, 0xd7, 0xc8, 0xc4, 0xdb, 0xa9, 0x10}}},
      {{{{0x31, 0xe8, 0xb8, 0xe,  0xb0, 0xc8, 0x1b, 0x73, 0x72, 0x2,  0xd3, 0xb8, 0xe2, 0x86, 0xc2, 0xdf,
          0xac, 0x53, 0x71, 0x3e, 0x24, 0x75, 0x36, 0x19, 0xcf, 0x4d, 0xc9, 0xa0, 0x5c, 0x5d, 0x73, 0xc9},
         {0x84, 0x9e, 0xc5, 0xc2, 0x63, 0xd,  0x1e, 0x33, 0x54, 0xd7, 0xcd, 0xad, 0xc0, 0x61, 0x7,  0xa3,
          0x49, 0x7a, 0xce, 0x2,  0xd7, 0x91, 0xfe, 0x68, 0x42, 0xec, 0xf0, 0x4f, 0x1c, 0xe5, 0x30, 0x8}}},
       {{0x95, 0x6e, 0x7,  0x4d, 0xcc, 0xc3, 0x56, 0x1,  0x13, 0x28, 0x92, 0x65, 0x26, 0x79, 0x52, 0x69,
         0xa4, 0xd5, 0x73, 0xca, 0x13, 0x2e, 0xb1, 0xbd, 0x23, 0xeb, 0xa7, 0xe2, 0xda, 0x32, 0xd5, 0xd9}}},
      {{{{0x31, 0xe8, 0xb8, 0xe,  0xb0, 0xc8, 0x1b, 0x73, 0x72, 0x2,  0xd3, 0xb8, 0xe2, 0x86, 0xc2, 0xdf,
          0xac, 0x53, 0x71, 0x3e, 0x24, 0x75, 0x36, 0x19, 0xcf, 0x4d, 0xc9, 0xa0, 0x5c, 0x5d, 0x73, 0xc9},
         {0xe4, 0xc0, 0x8c, 0x69, 0x46, 0xa3, 0xe5, 0x30, 0xe9, 0xc3, 0x67, 0x2f, 0xe, 0x28, 0x1d, 0xbd,
          0x4b, 0x67, 0x33, 0xdd, 0xe7, 0xcf, 0xe2, 0x26, 0x83, 0x8d, 0xc6, 0xca, 0xc, 0x8c, 0xb2, 0xd}}},
       {{0x59, 0x22, 0x95, 0x36, 0xbc, 0xc0, 0xe5, 0xa,  0x7c, 0x92, 0x50, 0xa5, 0x3d, 0xa5, 0xdc, 0x20,
         0x88, 0x7f, 0x59, 0x2a, 0x67, 0x63, 0x2b, 0x63, 0x7c, 0xb,  0x65, 0x7a, 0xdf, 0xfe, 0xbc, 0xf2}}},
      {{{{0x30, 0xd4, 0x94, 0x4b, 0xb6, 0xce, 0xba, 0x80, 0x12, 0xce, 0x76, 0x77, 0xdd, 0xcf, 0x15, 0x15,
          0xde, 0xc5, 0x9b, 0xef, 0xa3, 0xe6, 0xa1, 0x66, 0x5b, 0xf8, 0xf,  0xe4, 0x38, 0x37, 0x9,  0xd5},
         {0x81, 0x38, 0x63, 0x18, 0xa3, 0xf6, 0x7c, 0x5a, 0xa8, 0x54, 0x32, 0x74, 0x35, 0xf9, 0xc9, 0x1d,
          0x6a, 0x9d, 0xf5, 0xe,  0x9b, 0x45, 0xb3, 0x8f, 0x3e, 0x9f, 0xe9, 0xca, 0xdc, 0x76, 0xd9, 0x2}}},
       {{0x5d, 0xa,  0xbc, 0x6f, 0xcb, 0xab, 0x98, 0x63, 0x2,  0xd1, 0xc3, 0x59, 0x93, 0xef, 0x69, 0x2e,
         0x0,  0x4c, 0xe0, 0x53, 0x99, 0xd8, 0xa2, 0x72, 0xe4, 0x3b, 0xab, 0xc3, 0x55, 0xf9, 0xf9, 0xf4}}},
      {{{{0x30, 0xd4, 0x94, 0x4b, 0xb6, 0xce, 0xba, 0x80, 0x12, 0xce, 0x76, 0x77, 0xdd, 0xcf, 0x15, 0x15,
          0xde, 0xc5, 0x9b, 0xef, 0xa3, 0xe6, 0xa1, 0x66, 0x5b, 0xf8, 0xf,  0xe4, 0x38, 0x37, 0x9,  0xd5},
         {0x8a, 0xfd, 0xfc, 0x7a, 0x62, 0x68, 0x52, 0x6f, 0x8d, 0x46, 0xe,  0xb8, 0xe6, 0x95, 0x3b, 0x37,
          0x72, 0xf2, 0x65, 0x7a, 0x1d, 0x12, 0xb0, 0x87, 0x8c, 0x27, 0x7c, 0xc5, 0x65, 0x8a, 0x24, 0x6}}},
       {{0x61, 0xb,  0xa5, 0x9,  0x76, 0x1e, 0xf8, 0x25, 0x48, 0xaf, 0xc2, 0xfa, 0x44, 0x47, 0xed, 0xbd,
         0x31, 0x97, 0x1d, 0xdc, 0x43, 0x6e, 0xd,  0x15, 0x33, 0x38, 0x5,  0xd,  0xa2, 0x47, 0x93, 0xb0}}},
      {{{{0xaf, 0x4a, 0x62, 0x2f, 0x2e, 0x6d, 0xef, 0x2c, 0xba, 0xb2, 0x3e, 0xa2, 0x78, 0x4f, 0xd8, 0x33,
          0x96, 0x53, 0xd3, 0x5,  0xdb, 0x8,  0xbc, 0x72, 0xbe, 0xf3, 0x81, 0x5d, 0x41, 0x3a, 0xfb, 0xda},
         {0x5c, 0xcd, 0xc9, 0xb3, 0x70, 0x22, 0xda, 0x28, 0xe2, 0x98, 0xe,  0xa7, 0x62, 0x53, 0xb7, 0xd0,
          0x87, 0xe4, 0x8d, 0x86, 0x3f, 0xe9, 0x72, 0xd6, 0x78, 0x52, 0x8b, 0x5,  0x8f, 0x91, 0x4e, 0x3}}},
       {{0x48, 0x9c, 0xaf, 0xd9, 0x79, 0x49, 0x7,  0xd,  0x5e, 0x82, 0x4f, 0x7c, 0xec, 0x7e, 0x75, 0x95,
         0xbd, 0xaf, 0x8c, 0xc,  0xaa, 0x3,  0x5c, 0x34, 0x1,  0x9d, 0xd5, 0x35, 0xb8, 0xb7, 0x15, 0xc3}}},
      {{{{0xaf, 0x4a, 0x62, 0x2f, 0x2e, 0x6d, 0xef, 0x2c, 0xba, 0xb2, 0x3e, 0xa2, 0x78, 0x4f, 0xd8, 0x33,
          0x96, 0x53, 0xd3, 0x5,  0xdb, 0x8,  0xbc, 0x72, 0xbe, 0xf3, 0x81, 0x5d, 0x41, 0x3a, 0xfb, 0xda},
         {0x1d, 0xef, 0x2e, 0xe6, 0xbf, 0x92, 0x32, 0xae, 0x52, 0xcb, 0x71, 0x40, 0xca, 0xd5, 0xc5, 0x9d,
          0x63, 0xc2, 0x39, 0xcb, 0x6c, 0x8a, 0x5b, 0xbe, 0x52, 0xf6, 0xb3, 0x46, 0x9c, 0x77, 0x34, 0x7}}},
       {{0x43, 0x86, 0x65, 0x8f, 0x25, 0x69, 0x6c, 0x92, 0x57, 0x5a, 0x9a, 0x82, 0xb,  0x60, 0x49, 0xea,
         0xe7, 0xab, 0x20, 0x36, 0x81, 0x7a, 0x4e, 0xd7, 0xc8, 0xe,  0x3e, 0x3b, 0x72, 0xe9, 0x9b, 0x52}}},
      {{{{0x97, 0xb6, 0x99, 0xd0, 0x99, 0x5,  0x5f, 0x87, 0xc7, 0x91, 0xe3, 0x10, 0x5c, 0x1,  0xc7, 0x4,
          0xb5, 0x9,  0x5b, 0xb9, 0x1b, 0x9d, 0xeb, 0x23, 0x55, 0xbe, 0xaf, 0x0,  0x48, 0x95, 0x78, 0x8d},
         {0x3,  0xe8, 0xc2, 0xe8, 0x4,  0xb2, 0xff, 0x3b, 0xb2, 0x76, 0xb7, 0xe0, 0x56, 0xf5, 0xfc, 0x6a,
          0xb5, 0xda, 0x49, 0xd2, 0x72, 0x43, 0x30, 0x88, 0xfa, 0x6b, 0x4a, 0xf2, 0x92, 0xf2, 0xc9, 0x8}}},
       {{0xd9, 0x3b, 0x57, 0xb2, 0x3a, 0xf1, 0x95, 0x31, 0xf2, 0x2c, 0x5e, 0x88, 0x2f, 0x65, 0x7e, 0xd0,
         0xb1, 0xba, 0xb2, 0x58, 0x44, 0x98, 0x3e, 0xbd, 0xd8, 0xdf, 0x41, 0x63, 0xd0, 0x80, 0xed, 0xe6}}},
      {{{{0x97, 0xb6, 0x99, 0xd0, 0x99, 0x5,  0x5f, 0x87, 0xc7, 0x91, 0xe3, 0x10, 0x5c, 0x1,  0xc7, 0x4,
          0xb5, 0x9,  0x5b, 0xb9, 0x1b, 0x9d, 0xeb, 0x23, 0x55, 0xbe, 0xaf, 0x0,  0x48, 0x95, 0x78, 0x8d},
         {0x48, 0x0,  0xa5, 0xda, 0x40, 0x58, 0xcc, 0x11, 0x6a, 0x9f, 0xc2, 0x61, 0x47, 0x81, 0xe6, 0x11,
          0xc2, 0x8b, 0x31, 0x51, 0x20, 0xfd, 0x96, 0xc5, 0xa6, 0xe5, 0x1e, 0x65, 0xff, 0x5e, 0x56, 0xc}}},
       {{0x61, 0x4d, 0x7, 0x41, 0xfd, 0x37, 0x74, 0xb1, 0x60, 0x62, 0xf4, 0x17, 0x23, 0xf2, 0xe0, 0x44,
         0xc0, 0x66, 0x4, 0x58, 0x29, 0xb8, 0xae, 0x6c, 0x3b, 0xcc, 0x6f, 0x6,  0x1a, 0xe8, 0x54, 0x28}}},
      {{{{0xbc, 0xff, 0x50, 0xae, 0xf1, 0x98, 0xe,  0xa4, 0xc0, 0x4e, 0x15, 0x51, 0x42, 0xc2, 0x79, 0x9e,
          0x9d, 0x5e, 0xb0, 0x11, 0x31, 0x9c, 0xaf, 0x91, 0x29, 0x5c, 0xd7, 0xb8, 0x70, 0xfb, 0xde, 0x56},
         {0xc0, 0x5f, 0xe3, 0x69, 0xdc, 0x68, 0x76, 0x6b, 0xcc, 0x4d, 0x78, 0x9b, 0x66, 0xff, 0x6e, 0xb8,
          0x4f, 0x93, 0xa1, 0x73, 0xa5, 0x24, 0x4a, 0x5b, 0xe1, 0x44, 0x49, 0x65, 0xd8, 0x14, 0xa7, 0x1}}},
       {{0xf8, 0x7b, 0x55, 0xaa, 0xb5, 0xa8, 0xed, 0xf3, 0x29, 0x5d, 0x77, 0x58, 0x16, 0x1c, 0x9d, 0xb4,
         0xba, 0x28, 0xfa, 0x1,  0x7,  0xd2, 0xa5, 0x4c, 0x7a, 0x2,  0x20, 0xdc, 0x7f, 0x20, 0xaf, 0x67}}},
      {{{{0xbc, 0xff, 0x50, 0xae, 0xf1, 0x98, 0xe,  0xa4, 0xc0, 0x4e, 0x15, 0x51, 0x42, 0xc2, 0x79, 0x9e,
          0x9d, 0x5e, 0xb0, 0x11, 0x31, 0x9c, 0xaf, 0x91, 0x29, 0x5c, 0xd7, 0xb8, 0x70, 0xfb, 0xde, 0x56},
         {0xf7, 0xc,  0x1f, 0x6e, 0x90, 0xf7, 0xcf, 0x57, 0xf6, 0x98, 0xa9, 0xb5, 0xe6, 0x15, 0x2b, 0xa4,
          0xd,  0xd2, 0x30, 0xb6, 0xa4, 0xed, 0x36, 0x9a, 0xb4, 0x78, 0xad, 0x30, 0xf2, 0xae, 0x9d, 0xa}}},
       {{0xa,  0x7,  0xa,  0x7,  0x97, 0x9a, 0x54, 0xf9, 0xdc, 0xa9, 0xf7, 0xc2, 0x9b, 0x1e, 0x67, 0x8d,
         0x38, 0xf1, 0x65, 0xaf, 0x58, 0x5e, 0x69, 0xa2, 0xa9, 0xe7, 0x7a, 0xce, 0x3,  0x99, 0x51, 0x45}}},
      {{{{0x4d, 0x92, 0x57, 0xa3, 0xaf, 0x83, 0xac, 0xe5, 0x83, 0xd6, 0xb6, 0x8b, 0x5d, 0x48, 0x94, 0x8a,
          0xf8, 0xe9, 0x75, 0x61, 0xc6, 0x5b, 0xbd, 0xad, 0xa1, 0x76, 0x42, 0xee, 0xc,  0xd,  0x3e, 0x3f},
         {0xff, 0x14, 0x6f, 0x26, 0x8,  0x1a, 0xe4, 0x7d, 0x37, 0x2e, 0xad, 0xc9, 0xfe, 0xd0, 0x24, 0x6e,
          0x3e, 0x7e, 0x42, 0x7b, 0x55, 0xfd, 0x2d, 0x37, 0x3c, 0xfd, 0x1b, 0xb8, 0x3a, 0xe3, 0xf1, 0x4}}},
       {{0xb8, 0xae, 0x74, 0xd8, 0xcf, 0xbe, 0x76, 0x9b, 0xa7, 0x27, 0x12, 0xe4, 0x25, 0x0,  0x73, 0x2a,
         0x8c, 0xc2, 0xeb, 0x5d, 0xe6, 0x30, 0xab, 0x56, 0x62, 0x29, 0xa0, 0x7b, 0x2,  0x51, 0xed, 0xba}}},
      {{{{0x4d, 0x92, 0x57, 0xa3, 0xaf, 0x83, 0xac, 0xe5, 0x83, 0xd6, 0xb6, 0x8b, 0x5d, 0x48, 0x94, 0x8a,
          0xf8, 0xe9, 0x75, 0x61, 0xc6, 0x5b, 0xbd, 0xad, 0xa1, 0x76, 0x42, 0xee, 0xc,  0xd,  0x3e, 0x3f},
         {0x5e, 0x9c, 0xa3, 0x49, 0x8e, 0x80, 0x83, 0x26, 0xdc, 0x86, 0x15, 0x4b, 0xd1, 0xc,  0x7a, 0xa4,
          0x16, 0xbb, 0xe5, 0x17, 0x98, 0x7f, 0x28, 0x5b, 0x52, 0x3f, 0xce, 0x53, 0x65, 0xfc, 0xd6, 0x3}}},
       {{0xca, 0xf6, 0x71, 0x5a, 0xc6, 0x7a, 0xf5, 0xf1, 0xf5, 0x71, 0xd,  0xcd, 0x72, 0x44, 0xba, 0xcc,
         0x11, 0x74, 0x6a, 0x2f, 0xe1, 0xad, 0x88, 0xc3, 0x38, 0xe4, 0xf0, 0x65, 0x14, 0xbb, 0x6e, 0x1d}}},
      {{{{0xd1, 0x4e, 0x9c, 0x9a, 0x3a, 0x45, 0xe8, 0x1a, 0x14, 0xd3, 0x42, 0x8c, 0x25, 0x11, 0xd9, 0x83,
          0x70, 0xb1, 0x3d, 0x49, 0xfa, 0x37, 0xe6, 0x38, 0x8e, 0xcb, 0x66, 0x1f, 0x1e, 0x7f, 0x6a, 0x9f},
         {0x1d, 0xcb, 0xe3, 0x1f, 0xd8, 0xbe, 0x7d, 0x8f, 0x1d, 0x31, 0xa8, 0xce, 0x49, 0x35, 0x11, 0xe1,
          0x79, 0x32, 0xe4, 0xb4, 0x83, 0x8f, 0x6b, 0x24, 0xdc, 0x3c, 0xe8, 0xa8, 0x93, 0x11, 0x2,  0x9}}},
       {{0x78, 0xc0, 0x93, 0xcd, 0x5d, 0xc6, 0x13, 0x7d, 0x94, 0x3,  0xcc, 0x21, 0xe1, 0x30, 0x4b, 0xf5,
         0x1b, 0xd6, 0x82, 0x1a, 0x13, 0xd5, 0xf5, 0x3f, 0x56, 0xdc, 0x4e, 0x40, 0xab, 0x23, 0xd7, 0x39}}},
      {{{{0xd1, 0x4e, 0x9c, 0x9a, 0x3a, 0x45, 0xe8, 0x1a, 0x14, 0xd3, 0x42, 0x8c, 0x25, 0x11, 0xd9, 0x83,
          0x70, 0xb1, 0x3d, 0x49, 0xfa, 0x37, 0xe6, 0x38, 0x8e, 0xcb, 0x66, 0x1f, 0x1e, 0x7f, 0x6a, 0x9f},
         {0x5a, 0xe1, 0xc8, 0xf4, 0x39, 0xb1, 0x34, 0x36, 0x9b, 0x5,  0xde, 0x8d, 0x4f, 0xd9, 0x46, 0xd8,
          0xd6, 0x73, 0x97, 0x68, 0xdf, 0x8f, 0x34, 0xc9, 0x12, 0x1c, 0xce, 0xf8, 0x39, 0x65, 0x9e, 0xc}}},
       {{0xb4, 0xb,  0x68, 0xe2, 0x5f, 0x46, 0x4f, 0x93, 0x98, 0x5c, 0xd7, 0x40, 0xc9, 0xdc, 0x1,  0x50,
         0x12, 0x79, 0x9c, 0x43, 0xab, 0xf1, 0xfa, 0x21, 0x7e, 0x30, 0x9a, 0xbf, 0xf,  0x6c, 0x89, 0xf5}}},
      {{{{0x6a, 0x6d, 0x1b, 0x60, 0xd8, 0x33, 0xa0, 0x95, 0x7c, 0x9a, 0x3c, 0xef, 0x16, 0xff, 0xb3, 0x55,
          0x15, 0x10, 0x33, 0xc4, 0xf7, 0x61, 0x96, 0x15, 0xe8, 0x2a, 0xa0, 0xc8, 0x98, 0xdd, 0x18, 0x5a},
         {0xb1, 0x2b, 0xff, 0x33, 0xde, 0x12, 0xd0, 0xe,  0xe6, 0x83, 0x32, 0xc0, 0x46, 0xaa, 0x84, 0xbb,
          0x7a, 0x45, 0x5,  0x82, 0x9c, 0x3a, 0xef, 0xde, 0xe4, 0xd3, 0x87, 0xa,  0xc8, 0xea, 0x76, 0xc}}},
       {{0xd6, 0x65, 0x35, 0x15, 0xdf, 0x65, 0xee, 0xa,  0xe0, 0x95, 0xfe, 0x81, 0x60, 0x21, 0xdd, 0xca,
         0x43, 0xad, 0x5d, 0xe,  0x1,  0xc3, 0x3a, 0xab, 0x16, 0x92, 0x69, 0x1a, 0x76, 0xef, 0x5b, 0x1e}}},
      {{{{0x6a, 0x6d, 0x1b, 0x60, 0xd8, 0x33, 0xa0, 0x95, 0x7c, 0x9a, 0x3c, 0xef, 0x16, 0xff, 0xb3, 0x55,
          0x15, 0x10, 0x33, 0xc4, 0xf7, 0x61, 0x96, 0x15, 0xe8, 0x2a, 0xa0, 0xc8, 0x98, 0xdd, 0x18, 0x5a},
         {0x8b, 0x4c, 0x48, 0xa1, 0x4d, 0x8d, 0xde, 0x9b, 0x46, 0x65, 0xb8, 0x77, 0x41, 0x1e, 0x26, 0xed,
          0x66, 0x5e, 0xa5, 0x97, 0x81, 0x25, 0xfb, 0x80, 0xbf, 0x54, 0xe5, 0x9c, 0xbb, 0xcf, 0xb,  0x6}}},
       {{0xae, 0x65, 0x14, 0x8f, 0xbb, 0xa5, 0x3b, 0xc4, 0xfa, 0x14, 0x86, 0xb2, 0x3b, 0x3,  0x4c, 0x49,
         0xce, 0x27, 0x59, 0x47, 0xa5, 0x8a, 0xeb, 0xf6, 0x22, 0x5e, 0xc4, 0x1b, 0x39, 0xc7, 0x28, 0x61}}},
      {{{{0x6d, 0x7a, 0xc8, 0x2d, 0x78, 0xdc, 0x71, 0xe8, 0x29, 0x28, 0x44, 0x30, 0x37, 0xbd, 0xbc, 0x44,
          0x94, 0x49, 0xc6, 0xe6, 0x5,  0x3c, 0x1e, 0xd,  0x4c, 0x76, 0x3d, 0xe,  0xe6, 0x2b, 0xf8, 0x95},
         {0x61, 0x4,  0x43, 0x37, 0x85, 0xe6, 0x1c, 0x1e, 0xaf, 0xc6, 0x83, 0xce, 0xa8, 0xe1, 0xf9, 0x38,
          0x21, 0xe1, 0x3f, 0xc2, 0x86, 0xe2, 0xed, 0x7,  0x40, 0x3e, 0x80, 0x6d, 0x6,  0x77, 0xcf, 0x5}}},
       {{0x2b, 0xcb, 0x26, 0x76, 0x7a, 0x5f, 0x11, 0x31, 0x80, 0x4b, 0x10, 0xc3, 0x35, 0xbb, 0x6a, 0x95,
         0x5e, 0x61, 0x68, 0xfb, 0x3,  0x5,  0xb4, 0xe7, 0x82, 0x2d, 0xa4, 0x78, 0xa2, 0x27, 0xa6, 0x9d}}},
      {{{{0x6d, 0x7a, 0xc8, 0x2d, 0x78, 0xdc, 0x71, 0xe8, 0x29, 0x28, 0x44, 0x30, 0x37, 0xbd, 0xbc, 0x44,
          0x94, 0x49, 0xc6, 0xe6, 0x5,  0x3c, 0x1e, 0xd,  0x4c, 0x76, 0x3d, 0xe,  0xe6, 0x2b, 0xf8, 0x95},
         {0xdc, 0xd,  0x4e, 0xbb, 0x4c, 0x83, 0x7c, 0xf7, 0x94, 0x9,  0x5,  0x16, 0x37, 0xd,  0xac, 0x20,
          0xf0, 0xf8, 0x7c, 0x56, 0x1f, 0xe0, 0xd3, 0x89, 0x3b, 0x14, 0xa6, 0xaa, 0xb7, 0x2e, 0xf6, 0x0}}},
       {{0x23, 0x8e, 0x9d, 0x87, 0x44, 0x6f, 0x8,  0x6d, 0x2d, 0x9b, 0x7a, 0x24, 0x4e, 0x8b, 0xc2, 0x7a,
         0xb7, 0x5c, 0xe3, 0xe,  0xdf, 0x2c, 0x62, 0x5e, 0x4c, 0x25, 0x3c, 0x5a, 0x8,  0x9e, 0xf,  0x9e}}},
  }};

  for (const auto& oracle : Oracle) {
    const auto& input = oracle.first;
    const auto& expected = oracle.second;
    auto returnVariant = key_multiply_scalar(input[0], input[1]);
    Rct::Key inplaceVariant;
    key_mulitply_scalar_inplace(input[0], input[1], inplaceVariant);
    EXPECT_EQ(returnVariant, expected);
    EXPECT_EQ(inplaceVariant, expected);
  }
}
